* cz5_asm on Win1_misc & D111
* 29th May 2003
*
* At entry x0, y0 and y1 have been set. This defines the area to be covered.
*
* D1 = pointer to the PSA area to be filled.
*
* The PSA area will give the size of window (width/height) at PSA + 6
*
* The width must be double the height - else an error!
*
* The PSA area is filled with appropriate colours depending on the results of
* the inner loop.
*

	nolist
	in win1_ass_fp2_equ_asm
	in win1_lib_hed1
	list
; sm	  equ	  !.0000001
sys_clfp	equ	$d8
	bra	start
x0	ds.w	3	ql fp x0
y0	ds.w	3	ql fp y0
y1	ds.w	3	ql fp y1
y	ds.x	1
sm	dc.x	!.0000001

start	movea.l d1,a5		-> psa area
	MOVEQ	#MT_INF,D0	MT_INF = 0
	TRAP	#1		A0 = sys vars
	MOVE.L	SYS_CLFP(A0),D0 SYS_CLFP = $D8
	BEQ	ERROR	---->
	SUBA.L	A0,A0		signal "no user exception routines"
	JSR	(D0.L)
	TST.L	D0		OK? . . .
	BNE	ERROR	---->	. . . no

* Now convert x0,y0,y1 -> fp0,fp1,fp2

	move.l	y0+2,-(sp)
	move.w	y0,-(sp)
	jsr	q_to_i(a1)
	tst.l	d0
	bne	error1	---->
	fmove.x fp0,fp1 	FP1 = y0
	move.l	y1+2,2(sp)
	move.w	y1,(sp)
	jsr	q_to_i(a1)
	tst.l	d0
	bne	error1	---->
	fmove.x fp0,fp2 	FP2 = y1
	move.l	x0+2,2(sp)
	move.w	x0,(sp)
	jsr	q_to_i(a1)	FP0 = x0
	addq.l	#6,a7
	tst.l	d0
	movea.l a1,a2
	bne	error	---->
*
* Test psa size
*
	move.w	6(a5),d4	width
	lsr.w	#1,d4	should equal height
	bcs	error	---->
	cmp.w	8(a5),d4
	bne	error	---->
	bsr	ope	To open the indicator window
	moveq	#-1,d3
	moveq	#sd_clear,d0
	trap	#3
	moveq	#3,d1
	moveq	#1,d2
	moveq	#sd_bordr,d0
	trap	#3
	fmove.l #32768,fp6
	fsub.x	fp1,fp2 y1 - y0
	fdiv.w	d4,fp2	a = (y1 - y0)/ysz
	fmovem.x	fp0-2,-(sp)	A7 = x0, y0, a
	move.w	d4,d2	height (= no of lines s)
	bra	olp1
olp
	fmove.x 24(sp),fp0	a
	fmul.w	d2,fp0		a*s
	fadd.x	12(sp),fp0	y
	lea	y,a1
	fmove.x fp0,(a1)
	move.w	6(a5),d1		x-count
	move.w	8(a5),d3		height in pixels
	subq.w	#1,d3		 . . less 1
	sub.w	d2,d3		 . . less y-count
	mulu.w	10(a5),d3	pointer to start of line
	bra	xlp1
xlp	fmove.x y,fp1		y -> FP1
	fmove.x 24(sp),fp0	a -> FP0
	fmul.w	d1,fp0		r*a
	fadd.x	(sp),fp0		x = x0 +r*a
	moveq	#0,d7	ct -> 0
loop	fmove.x fp0,fp5 x
	fmul.x	fp5,fp5 x^2
	fmove.x fp5,fp3 keep x^2 in FP3
	fmove.x fp1,fp2 y
	fmul.x	fp2,fp2 y^2
	fmove.x fp2,fp4 keep y^2 in FP4
	fadd.x	fp2,fp5 x^2 + y^2
	fmove.x fp0,-(sp)
	fmove.x fp6,-(sp)
	fmove.x fp5,-(sp)
	jsr	fmodx(a2)
	lea	2*12(sp),sp
	fmove.w fp0,d6
	andi.w	#$ff,d6
	fmove.x (sp)+,fp0
*
* At end of inner loop find colour and insert it in PSA
*
	move.w	d1,d4	x-count
	add.w	d4,d4	x-count * 2
	ext.l	d4	-> D4.L
	add.l	d3,d4	add line position
	move.w	cols(d6.w*2),14(a5,d4.l)	set pixel
xlp1	dbf	d1,xlp
	bsr	mark
olp1	dbf	d2,olp
*
*
	lea	36(a7),a7	restore stack pointer
	bsr	shut
	moveq	#0,d0
	rts

error1	addq.l	#4,a7
error	moveq	#-15,d0
	rts

oreg	reg	d1/d3
	hed1	"scr_204x32a10x470",scr

ope	movem.l oreg,-(sp)
	lea	scr,a0
	moveq	#-1,d1
	moveq	#0,d3
	moveq	#io_open,d0
	trap	#2
	movem.l (sp)+,oreg
	tst.l	d0
	beq	ope1
	addq.l	#4,sp
ope1	rts
mreg	reg	d3/a1
;
; To mark progress
; A0 = ID
; 8(A5) is the height in pixels
; D2.W is the count so far
;
mark	movem.l mreg,-(sp)
	moveq	#-1,d3
	lea	block,a1
	move.w	8(a5),d1
	sub.w	d2,d1
	mulu.w	#200,d1
	divu.w	8(a5),d1
	move.w	d1,(a1)
	moveq	#4,d1	green
	moveq	#sd_fill,d0
	trap	#3
	movem.l (sp)+,mreg
	rts

shut	moveq	#-1,d3	timeout
	moveq	#0,d1	border width
	moveq	#0,d2	colour
	moveq	#sd_bordr,d0
	trap	#3
	moveq	#sd_clear,d0
	trap	#3
	moveq	#io_close,d0
	trap	#2
	rts

block	dc.w	0,30,0,0


cols
 DC.W 0
 DC.W -2
 DC.W 1984
 DC.W -2048
 DC.W 62
 DC.W 2046
 DC.W -64
 DC.W -1986
 DC.W 8456
 DC.W 19026
 DC.W 27482
 DC.W -27484
 DC.W -19028
 DC.W -8458
 DC.W 1152
 DC.W -596
 DC.W -27520
 DC.W -28672
 DC.W -28636
 DC.W 36
 DC.W 1188
 DC.W 2020
 DC.W -26688
 DC.W -896
 DC.W -2012
 DC.W -28610
 DC.W 1214
 DC.W -18452
 DC.W -20
 DC.W -578
 DC.W -19010
 DC.W -18434
 DC.W -18442
 DC.W -8212
 DC.W -8202
 DC.W -10
 DC.W -266
 DC.W -258
 DC.W -8450
 DC.W -8194
 DC.W 28058
 DC.W -19046
 DC.W -19622
 DC.W -19604
 DC.W 27500
 DC.W 28076
 DC.W 9032
 DC.W 27464
 DC.W 26888
 DC.W 26906
 DC.W 8474
 DC.W 9050
 DC.W 19876
 DC.W -27246
 DC.W -19310
 DC.W -19868
 DC.W -28052
 DC.W 19628
 DC.W 1170
 DC.W 19584
 DC.W -28096
 DC.W -28654
 DC.W 18468
 DC.W 612
 DC.W 18
 DC.W 264
 DC.W 282
 DC.W 300
 DC.W 318
 DC.W 576
 DC.W 594
 DC.W 630
 DC.W 840
 DC.W 858
 DC.W 876
 DC.W 894
 DC.W 1416
 DC.W 1434
 DC.W 1452
 DC.W 1470
 DC.W 1728
 DC.W 1746
 DC.W 1764
 DC.W 1782
 DC.W 2010
 DC.W 8192
 DC.W 8210
 DC.W 8228
 DC.W 8246
 DC.W 8492
 DC.W 8510
 DC.W 8768
 DC.W 8786
 DC.W 8804
 DC.W 8822
 DC.W 9068
 DC.W 9086
 DC.W 9344
 DC.W 9362
 DC.W 9380
 DC.W 9398
 DC.W 9608
 DC.W 9626
 DC.W 9644
 DC.W 9662
 DC.W 9920
 DC.W 9938
 DC.W 9956
 DC.W 9974
 DC.W 10184
 DC.W 10202
 DC.W 10220
 DC.W 10238
 DC.W 18432
 DC.W 18450
 DC.W 18486
 DC.W 18696
 DC.W 18714
 DC.W 18732
 DC.W 18750
 DC.W 19008
 DC.W 19044
 DC.W 19062
 DC.W 19272
 DC.W 19290
 DC.W 19308
 DC.W 19326
 DC.W 19602
 DC.W 19638
 DC.W 19848
 DC.W 19866
 DC.W 19902
 DC.W 20160
 DC.W 20178
 DC.W 20196
 DC.W 20214
 DC.W 20424
 DC.W 20442
 DC.W 20460
 DC.W 20478
 DC.W 26624
 DC.W 26642
 DC.W 26660
 DC.W 26678
 DC.W 26924
 DC.W 26942
 DC.W 27200
 DC.W 27218
 DC.W 27236
 DC.W 27254
 DC.W 27518
 DC.W 27776
 DC.W 27794
 DC.W 27812
 DC.W 27830
 DC.W 28040
 DC.W 28094
 DC.W 28352
 DC.W 28370
 DC.W 28388
 DC.W 28406
 DC.W 28616
 DC.W 28634
 DC.W 28652
 DC.W 28670
 DC.W -28408
 DC.W -28390
 DC.W -28372
 DC.W -28354
 DC.W -28078
 DC.W -28042
 DC.W -27832
 DC.W -27814
 DC.W -27796
 DC.W -27778
 DC.W -27502
 DC.W -27466
 DC.W -27256
 DC.W -27220
 DC.W -27202
 DC.W -26944
 DC.W -26926
 DC.W -26908
 DC.W -26890
 DC.W -26662
 DC.W -26644
 DC.W -26626
 DC.W -20480
 DC.W -20462
 DC.W -20444
 DC.W -20426
 DC.W -20216
 DC.W -20198
 DC.W -20180
 DC.W -20162
 DC.W -19904
 DC.W -19886
 DC.W -19850
 DC.W -19640
 DC.W -19586
 DC.W -19328
 DC.W -19292
 DC.W -19274
 DC.W -19064
 DC.W -18752
 DC.W -18734
 DC.W -18716
 DC.W -18698
 DC.W -18488
 DC.W -18470
 DC.W -10240
 DC.W -10222
 DC.W -10204
 DC.W -10186
 DC.W -9976
 DC.W -9958
 DC.W -9940
 DC.W -9922
 DC.W -9664
 DC.W -9646
 DC.W -9628
 DC.W -9610
 DC.W -9400
 DC.W -9382
 DC.W -9364
 DC.W -9346
 DC.W -9088
 DC.W -9070
 DC.W -9052
 DC.W -9034
 DC.W -8824
 DC.W -8806
 DC.W -8788
 DC.W -8770
 DC.W -8494
 DC.W -8476
 DC.W -8230
 DC.W -2030
 DC.W -1766
 DC.W -1748
 DC.W -1472
 DC.W -1454
 DC.W -1436
 DC.W -1418
 DC.W -1208
 DC.W -1190
 DC.W -1172
 DC.W -1154
 DC.W -878
 DC.W -860
 DC.W -842
 DC.W -632
 DC.W -614
 DC.W -302
 DC.W -284
 DC.W -38
